package top.xkshadow.SkyHole;

import cn.nukkit.Player;
import cn.nukkit.Server;
import cn.nukkit.entity.Entity;
import cn.nukkit.level.Position;
import cn.nukkit.level.Sound;
import cn.nukkit.network.protocol.PlaySoundPacket;
import java.util.Iterator;
import top.xkshadow.SkyHole.Task.Server.DelayTaskControll;

public class Sounds {
   public static void addSound(Entity p, Sound s) {
      p.level.addSound(p.getPosition(), s);
   }

   public static void addCustomSound(Player p, String s) {
      addCustomSound(p, s, 1.0F);
   }

   public static void addCustomSound(Player p, String s, Float volume) {
      PlaySoundPacket pk2 = new PlaySoundPacket();
      pk2.volume = volume;
      pk2.x = p.getFloorX();
      pk2.y = p.getFloorY();
      pk2.z = p.getFloorZ();
      pk2.name = s;
      pk2.pitch = 1.0F;
      p.dataPacket(pk2);
   }

   public static void addCustomSound(Position pos, String s) {
      Iterator var2 = Server.getInstance().getOnlinePlayers().values().iterator();

      while(var2.hasNext()) {
         Player p = (Player)var2.next();
         if (p.getPosition().distance(pos) <= 30.0D) {
            PlaySoundPacket pk2 = new PlaySoundPacket();
            pk2.volume = 1.0F;
            pk2.x = pos.getFloorX();
            pk2.y = pos.getFloorY();
            pk2.z = pos.getFloorZ();
            pk2.name = s;
            pk2.pitch = 1.0F;
            p.dataPacket(pk2);
         }
      }

   }

   public static void addSound(Position pos, Sound s) {
      pos.level.addSound(pos, s);
   }

   public static void EntityDeathSound(Player p) {
      String id = p.getInventory().getItemInHand().getNamespaceId();
      if (id.contains("spear")) {
         addCustomSound(p, "sound.attack.stab");
      }

      if (id.contains("great")) {
         addCustomSound(p, "sound.attack.big_sweep");
      }

      if (id.contains("sword")) {
         addCustomSound(p, "sound.attack.splatter");
      }

   }

   public static void waitSound(final Entity p, final Sound s, int tick) {
      DelayTaskControll.addTask(new Runnable() {
         public void run() {
            p.level.addSound(p.getPosition(), s);
         }
      }, tick);
   }

   public static void waitSound(final Position p, final Sound s, int tick) {
      DelayTaskControll.addTask(new Runnable() {
         public void run() {
            p.level.addSound(p, s);
         }
      }, tick);
   }
}
